/*
 * sort3.c - s̐
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define LINE_SIZE       (4096 + 2)
#define MAX_LINES       1000
#define YES             1
#define NO              0

extern char *strdup(const char *);

void  sort(int);
int   read_line(FILE *, int);
void  write_line(FILE *, int);
int   mycomp(const char **, const char **);
int   striccmp(const char *, const char *);
void  usage(void);
void  cant(char *);
void  error(char *);

char  *line[MAX_LINES];
int   r_flag = NO;      /* ~ɂ邩ǂ */
int   f_flag = NO;      /* 啶/ʂ邩ǂ */


main(int argc, char **argv)
{
    FILE  *fp;
    char  *s;
    int   n;

    while (--argc > 0 && **++argv == '-') {
        for (s = *argv + 1; *s != '\0'; s++) {
            switch (*s) {
            case 'f':
                f_flag = YES;
                break;
            case 'r':
                r_flag = YES;
                break;
            default:
                usage();
            }
        }
    }

    n = 0;
    if (argc == 0) {
        n = read_line(stdin, 0);    /*  */
        sort(n);                    /*  */
        write_line(stdout, n);      /* o */
    }
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv);
            n += read_line(fp, n);  /*  */
            fclose(fp);
            argv++;
        }
        sort(n);                    /*  */
        write_line(stdout, n);      /* o */
    }
    return (0);
}


/* f[^SǂݍŋL */
int read_line(FILE *fp, int m)
{
    char tmp[LINE_SIZE];
    int  i;

    for (i = 0; fgets(tmp, LINE_SIZE, fp) != NULL; i++) {
        if (i + m < MAX_LINES) {
            if ((line[i + m] = strdup(tmp)) == NULL)
                error("can't alloc memory");
        }
        else
            error("too many lines");
    }
    return (i);
}


/* ̃f[^o */
void write_line(FILE *fp, int n)
{
    int  i;

    for (i = 0; i < n; i++) {
        fputs(line[i], fp);
        free(line[i]);
    }
}


/* f[^̐ */
void  sort(int n)
{
    qsort(line, n, sizeof(char *), mycomp);
}


/* 2̗vf̔rp֐ */
int   mycomp(const char **a, const char **b)
{
    if (f_flag == YES) { /* 啶/ʂȂ */
        if (r_flag == NO)
            return (striccmp(*a, *b));
        else
            return (striccmp(*b, *a));
    }
    else {
        if (r_flag == NO)
            return (strcmp(*a, *b));
        else
            return (strcmp(*b, *a));
    }
}


/*
 * striccmp - 啶/ʂɔr
 *      s > t: ̒l
 *      s = t: 0
 *      s < t: ̒l
 */
int striccmp(const char *s, const char *t)
{
    while (tolower(*s) == tolower(*t)) {
        if (*s == '\0')
            return (0);
        ++s;
        ++t;
    }
    return (tolower(*s) - tolower(*t));
}


/* R}h̐\ďI */
void  usage(void)
{
    fprintf(stderr, "Usage: sort3 [file ...]\n");
    exit(1);
}


/* fileopenłȂƂ\ďI */
void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}


/* G[bZ[W\ďI */
void  error(char *str)
{
    fprintf(stderr, "%s\n", str);
    exit(1);
}


/* KvȂ̃GAmۂɕ𕡎 */
char  *strdup(const char *p)
{
    char  *r;

    if ((r = malloc(strlen(p) + 1)) == NULL) /* +1 for '\0' */
        return (NULL);
    strcpy(r, p);
    return (r);
}
