/*
 * page2.c - eLXgt@C1ʂ\
 */
#include <stdio.h>
#include <stdlib.h>

#define LINE_SIZE    (80 + 1 + 1) /* 80 + s̕ + '\0'̕ */
#define LINES_PAGE  23           /* 1ʂɕ\s */
#define R_QUIT_ALL  0            /* ׂďI */
#define R_PAGE_NEXT 1            /* page */
#define R_FILE_NEXT 2            /* file */


static int   paging(FILE *, int);
static int   key_wait(void);
static void  usage(void);
static void  cant(char *);


main(int argc, char **argv)
{
    FILE  *fp;
    int   r;

    --argc;
    ++argv;
    if (argc == 0)
        usage();
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv);
            r = paging(fp, LINES_PAGE);
            (void)fclose(fp);
            if (r == R_QUIT_ALL)
                break;
            argv++;
        }
    }
    return (0);
}


/*
 * paging() - 1ʂƂɕ\Ď~܂莟̃L[͂҂
 */
static int   paging(FILE *fp, int n)
{
    char  buf[LINE_SIZE];
    int   r;
    int   i;

    i = 0;
    while (fgets(buf, LINE_SIZE, fp) != NULL) {
        fputs(buf, stdout);
        if (i++ >= n - 1) {
            if ((r = key_wait()) != R_PAGE_NEXT)
                return (r);
            i = 0;
        }
    }
    if (i > 0) {
        if ((r = key_wait()) != R_PAGE_NEXT)
            return (r);
    }
    return (R_FILE_NEXT);
}

#if HAVE_GETCH
/*
 * ket_wait() - L[̂҂(getch)
 */
static int   key_wait(void)
{
    int   c;

    fprintf(stderr, "--more--");
    while ((c = getch()) != 'q' && c != ' ' && c != 'n')
        ;
    if (c == 'q')
        return (R_QUIT_ALL);
    else if (c == 'n')
        return (R_FILE_NEXT);
    else
        return (R_PAGE_NEXT);
}
#else
/*
 * ket_wait() - L[̂҂(fgets)
 */
static int   key_wait(void)
{
    char  comline[LINE_SIZE];

    fprintf(stderr, "--Hit Return Key--");
    (void)fgets(comline, LINE_SIZE, stdin);
    if (comline[0] == 'q')
        return (R_QUIT_ALL);
    else if (comline[0] == 'n')
        return (R_FILE_NEXT);
    else
        return (R_PAGE_NEXT);
}
#endif


static void  usage(void)
{
    fprintf(stderr, "Usage: page2 file [...]\n");
    exit(1);
}


static void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}
